(* to read configuration files.  (initialize None) looks for default
   configuration files in the current and home directories.  (initialize
   (Some path)) reads configurations from the given path. *)
val initialize : string option -> unit

(* the path to extconf.rb, which is used for building a makefile for
   generated C++/CUDA programs *)
val extconf_path : unit -> string

(* the path to the parray library, including parray.rb as well as
   parray_c.so *)
val parray_dir          : unit -> string
val parray_dir_relative : unit -> string

(* the path to the Ruby interepreter. *)
val path_to_ruby : unit -> string

(* the path to Ikra's runtime directory *)
val ikra_root_directory : unit -> string
