(* val extconf_path : string *)
(* val parray_dir : string *)
(* exception Build_error of string *)

type kind = Initialize | Map | Reduce | UnitlessReduce
val string_of_kind : kind -> string
val element_type_of : Ikra_type.t -> Ikra_type.t
type kernel = {
  kind : kind;
  name : string;
  free_vars : Ast.tast list;
  params : Ast.parameter_pattern;
  type_decls : Ast.type_decl list;
  body : Ast.tast list;
  body_type : Ikra_type.t;
  receiver : Ast.tast;
  top_decls : Ast.tast;
  return_type : Ikra_type.t;
}
val top_decls : kernel list -> Ast.tast list
(* val fv_name : Ast.tast -> string *)
type var_iname_type_cname = Ast.tast * string
type env = {
  wrapper_name : string;
  kernel_fun_name : string;
  body_fun_name : string;
  argspecs : var_iname_type_cname list;
  body_ctype : Cuda.cuda_type;
  fvspecs : (Ast.tast * string) list;
  body_args : (Cuda.cuda_type * Cuda.variable) list;
  element_statements : Cuda.statement list;
}
(* val unwrap : var_iname_type_cname -> Cuda.exp -> Cuda.exp *)
(* val make_var : Ikra_type.t * string -> var_iname_type_cname *)
(* val wrapper_arg : var_iname_type_cname -> Cuda.cuda_type * string *)
(* val loop_arg : var_iname_type_cname -> Cuda.cuda_type * string *)
(* val wrap_c_value : Cuda.cuda_type -> Cuda.exp -> Cuda.exp *)
(* val wrapper_template : env -> kind -> Cuda.fundef *)
(* val split_last : 'a list -> 'a list * 'a *)
(* val loop_template : env -> kind -> Cuda.fundef *)
(* val body_template : env -> kind -> Cuda.fundef *)
(* val zero_to : int -> int list *)
(* val generate_env : kernel -> env *)
(* val generate_functions : kernel -> Cuda.fundef list *)
(* val generate_preamble : string -> kernel list -> string *)
(* module Gather_auxiliary_methods : *)
(*   sig *)
(*     val called_methods : Ast.tast -> string list *)
(*     val maybe_called_methods : Ast.tast option -> string list *)
(*     val map_called_methods : Ast.tast list -> string list *)
(*     val directly_called : kernel -> string list *)
(*     module MnameSet : *)
(*       sig *)
(*         type elt = String.t *)
(*         type t = Set.Make(String).t *)
(*         val empty : t *)
(*         val is_empty : t -> bool *)
(*         val mem : elt -> t -> bool *)
(*         val add : elt -> t -> t *)
(*         val singleton : elt -> t *)
(*         val remove : elt -> t -> t *)
(*         val union : t -> t -> t *)
(*         val inter : t -> t -> t *)
(*         val diff : t -> t -> t *)
(*         val compare : t -> t -> int *)
(*         val equal : t -> t -> bool *)
(*         val subset : t -> t -> bool *)
(*         val iter : (elt -> unit) -> t -> unit *)
(*         val fold : (elt -> 'a -> 'a) -> t -> 'a -> 'a *)
(*         val for_all : (elt -> bool) -> t -> bool *)
(*         val exists : (elt -> bool) -> t -> bool *)
(*         val filter : (elt -> bool) -> t -> t *)
(*         val partition : (elt -> bool) -> t -> t * t *)
(*         val cardinal : t -> int *)
(*         val elements : t -> elt list *)
(*         val min_elt : t -> elt *)
(*         val max_elt : t -> elt *)
(*         val choose : t -> elt *)
(*         val split : elt -> t -> t * bool * t *)
(*       end *)
(*     val gather : kernel list -> (string * Ast.tast) list *)
(*   end *)
(* val generate_aux_functions : string -> kernel list -> string *)
(* val wrapper_registration : *)
(*   Cuda.exp -> string -> Cuda.fundef -> Cuda.statement *)
(* val generate_initializer : *)
(*   string -> kernel list -> Cuda.fundef list -> string *)
val generate_makefile : generate_only:bool -> Convert_env.t -> unit
val cuda_code_of : string -> kernel list -> string

val cxx_suffix : string 
val backend_name : string
