type craint_t = Type_constraints.Constr.t
type craints_t = Type_constraints.Constraints.t
type subst_t = (Ikra_type.t * Ikra_type.t) list

(* failure of type inference with two pairs of an expression and a set
   of unresolved constraints.  Some of the expression types are
   replaced with concrete ones as inferenced.  The first pair is the
   result of inference with rules up to the second level, and the
   second is the third level. *)
exception Unresolved of Ast.tast * craints_t * Ast.tast * craints_t

(* val empty_subst : subst_t *)
(* val apply_to_subst : subst_t -> subst_t -> subst_t *)
(* val apply_to_parameter_pattern : *)
(*   subst_t -> Ast.parameter_pattern -> Ast.parameter_pattern *)
(* val apply_to_ast : subst_t -> Ast.tast -> Ast.tast *)
val unify : craints_t * subst_t -> craints_t * subst_t
(* val arith_ops : string list *)
(* val compare_ops : string list *)
(* type side_condition = craint_t -> bool *)
(* val second_level_rules : *)
(*   craint_t -> (side_condition -> craint_t option) -> craint_t list *)
(* val third_level_rules : *)
(*   craint_t -> (side_condition -> craint_t option) -> craint_t list *)
val set_print : Type_constraints.Constraints.t -> string
(* val domain_specific_resolution : *)
(*   (Type_constraints.Constraints.elt -> *)
(*    ((Type_constraints.Constraints.elt -> bool) -> *)
(*     Type_constraints.Constraints.elt option) -> *)
(*    Type_constraints.Constraints.elt list) -> *)
(*   craints_t * subst_t -> craints_t * subst_t *)
(* val resolve_two : craints_t * subst_t -> craints_t * subst_t *)
(* val resolve_three : craints_t * subst_t -> craints_t * subst_t *)
(* val fix : ('a -> 'a) -> 'a -> 'a *)
(* val resolve_one_two : craints_t * subst_t -> craints_t * subst_t *)
(* val resolve_one_to_three : craints_t * subst_t -> craints_t * subst_t *)
val resolve : craints_t -> craints_t * subst_t
val typeinf : Ast.tast -> Ast.tast

(* for testing only *)
val apply_to_craint : subst_t -> craint_t -> craint_t
val apply_to_type : subst_t -> Ikra_type.t -> Ikra_type.t
val apply_to_craints : subst_t -> craints_t -> craints_t
val process_rule : craint_t -> craints_t * subst_t -> craints_t * subst_t
val remove_cycle : craints_t * subst_t -> craints_t * subst_t
val trace : (craints_t * subst_t -> unit) ref
val resolve_one : craints_t * subst_t -> craints_t * subst_t
val resolve_one' : craints_t -> craints_t * subst_t
val show_trace : bool ref

