type t =
    Tint
  | Tfloat
  | Tbool
  | Trange                              (* a pair (or triple) of numbers *)
  | Tarray of int * t
  | Tneighbor of int * int * t   (* (m,n,t) m-neighbor expanded Tarray(n,t) *)
  | Tobject
  | Tvar of int
  | Tclass of string
  | Ttuple of t list
  (* methods and argument blocks, where Tproc([t1;..;tn], t0, Some
     (Tproc t)) denotes a method that receives n parameters of type
     t1..tn, returns values of type t0, and takes a block argument of
     type Tproc t. *)
  | Tproc of t list * t * t option
val string_of : t -> string
val compare : t -> t -> int
