(* utility function for testing *)

let with_string : (string -> 'a) -> string -> 'a =
  (* with_string f str writes the contents of str in a temporary file,
     and then applies the name of the temporary file to f. *)

  fun f str -> Util.with_temp_file "ikra_test" ".txt" str f

let parse_ruby_string : string -> Ast.tast =
  fun source ->
    try
      with_string Parser.parse_file source
    with Invalid_argument(m) ->
      invalid_arg (Printf.sprintf "error (%s) while parsing %s"
			  m source)

let safe_read_lines : string -> string =
  (* returns a string in the given filename, or an error message if
     something goes wrong *)
  
  fun filename -> try Util.read_lines filename
    with Sys_error m -> "**ERROR**"^m


let compare_programs : string -> string -> string =
  fun expected actual ->
    Util.run_command 
      ["dwdiff"; "-d"; "\"!%^&*()-+{}[]|\\:;'<>,./?\ \"%s\" \"%s\"";
       expected; actual]

      
