val read_lines_list : string -> string list
val read_lines : string -> string
val with_finally : (unit -> 'a) -> (unit -> unit) -> 'a
val with_temp_file : string -> string -> string -> (string -> 'a) -> 'a
val make_temp_dir : string -> string
val with_cd : string -> (unit -> 'a) -> 'a
(* val path_to_ruby : 'a -> string *)
exception External_command_error of string * string * string
val run_command : ?redirect:bool -> string list -> string
val run_ruby : ?redirect:bool -> string list -> string
val in_paren : string -> string
module Option :
  sig
    val maybe : ('a -> 'b) -> 'a option -> 'b option
    val is_some : 'a option -> bool
    exception No_value
    val get : 'a option -> 'a
  end
val take : int -> 'a list -> 'a list
val drop : int -> 'a list -> 'a list
val mapi : (int -> 'a -> 'b) -> 'a list -> 'b list

(* split_last [v1;...;vn;vn+1] = ([v1;...;vn], vn+1) *)
val split_last : 'a list -> 'a list * 'a
