# Two outputs are correct if 
#  - they can be parsed as Ruby arrays
#  - they have the same length
#  - no more than TOLERANCE percent of elements are different
#
# Due to the differences of floating precisions, the results can be
# different at the boundary of the set.  Hence the custom comparator
# is used here.

TOLERANCE = 5 # in percentage

def custom_assert(expected, actual, message)
  assert_block message do
    expeted_val = eval(expected)
    actual_val = eval(actual)
    if (el = expeted_val.length) != (al = actual_val.length)
      assert(false,
             "<#{actual_val}> has different length (#{al}) from the that (#{el}) of acted\n<#{expeted_val}>")
    else
      assert((diffs = expeted_val.zip(actual_val).reduce(0){ |c, (ev,av)|
             c += ev==av ? 0 : 1 
           }) < el*TOLERANCE / 100,
           "<#{actual_val}> has too many different elements (#{diffs}) from the  actual\n<#{expeted_val}>")
    end
  end
end
